"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = eslintConfigGenerator;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _ansiColors = _interopRequireDefault(require("ansi-colors"));

var _constants = _interopRequireDefault(require("../constants"));

var _isUsingTS = _interopRequireDefault(require("../utils/isUsingTS"));

var _pkgManager = _interopRequireDefault(require("../utils/pkgManager"));

function eslintConfigGenerator() {
  return _eslintConfigGenerator.apply(this, arguments);
}

function _eslintConfigGenerator() {
  _eslintConfigGenerator = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var isTypeScript, packages, configurationPath, eslintConfiguration;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log(_ansiColors["default"].blue('\nConfiguring Eslint 🔨 🔨'));
            _context.next = 3;
            return (0, _isUsingTS["default"])();

          case 3:
            isTypeScript = _context.sent;
            packages = ['eslint', 'eslint-config-airbnb', 'eslint-plugin-import', 'eslint-plugin-jsx-a11y', 'eslint-plugin-react', 'eslint-plugin-react-hooks', 'eslint-plugin-jest', 'eslint-plugin-testing-library', 'eslint-plugin-jest-dom'].concat((0, _toConsumableArray2["default"])(isTypeScript ? ['@typescript-eslint/parser', '@typescript-eslint/eslint-plugin', 'eslint-config-airbnb-typescript'] : []));
            _context.next = 7;
            return _pkgManager["default"].addDevDeps(packages);

          case 7:
            configurationPath = _path["default"].join(_constants["default"].configFolder, isTypeScript ? 'eslint-react-ts.json' : 'eslint-react-js.json');
            _context.next = 10;
            return _fsExtra["default"].readJSON(configurationPath);

          case 10:
            eslintConfiguration = _context.sent;
            _context.next = 13;
            return _fsExtra["default"].writeJSON('.eslintrc.json', eslintConfiguration, {
              spaces: 2
            });

          case 13:
            _context.next = 15;
            return addScripts();

          case 15:
            console.log(_ansiColors["default"].blue('\nEslint successfully configured 🎉 🎉'));

          case 16:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _eslintConfigGenerator.apply(this, arguments);
}

function addScripts() {
  return _addScripts.apply(this, arguments);
}

function _addScripts() {
  _addScripts = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return _pkgManager["default"].addScripts({
              'eslint:check': 'eslint . --ext .js,.jsx,.ts,.tsx --ignore-path .gitignore --report-unused-disable-directives --max-warnings 0',
              'eslint:fix': 'eslint . --fix --ext .js,.jsx,.ts,.tsx --ignore-path .gitignore --report-unused-disable-directives --max-warnings 0'
            });

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _addScripts.apply(this, arguments);
}