"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = stylelintConfigGenerator;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

var _ansiColors = _interopRequireDefault(require("ansi-colors"));

var _constants = _interopRequireDefault(require("../constants"));

var _isUsingSCSS = _interopRequireDefault(require("../utils/isUsingSCSS"));

var _pkgManager = _interopRequireDefault(require("../utils/pkgManager"));

function stylelintConfigGenerator() {
  return _stylelintConfigGenerator.apply(this, arguments);
}

function _stylelintConfigGenerator() {
  _stylelintConfigGenerator = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var isSCSS, configurationPath, stylelintConfiguration;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log(_ansiColors["default"].blue('\nConfiguring Stylelint 🔨 🔨'));
            _context.next = 3;
            return (0, _isUsingSCSS["default"])();

          case 3:
            isSCSS = _context.sent;
            _context.next = 6;
            return _pkgManager["default"].addDevDeps(['stylelint', isSCSS ? 'stylelint-config-standard-scss' : 'stylelint-config-standard']);

          case 6:
            configurationPath = _path["default"].join(_constants["default"].configFolder, isSCSS ? 'stylelint-scss.json' : 'stylelint-css.json');
            _context.next = 9;
            return _fsExtra["default"].readJSON(configurationPath);

          case 9:
            stylelintConfiguration = _context.sent;
            _context.next = 12;
            return _fsExtra["default"].writeJSON('.stylelintrc.json', stylelintConfiguration, {
              spaces: 2
            });

          case 12:
            _context.next = 14;
            return addScripts();

          case 14:
            console.log(_ansiColors["default"].blue('\nStylelint successfully configured 🎉 🎉'));

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _stylelintConfigGenerator.apply(this, arguments);
}

function addScripts() {
  return _addScripts.apply(this, arguments);
}

function _addScripts() {
  _addScripts = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return _pkgManager["default"].addScripts({
              'stylelint:check': 'stylelint **/*.{css,scss,sass} --ignore-path .gitignore --max-warnings 0',
              'stylelint:fix': 'stylelint **/*.{css,scss,sass} --fix --ignore-path .gitignore --max-warnings 0'
            });

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _addScripts.apply(this, arguments);
}