"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _child_process = require("child_process");

var _ansiColors = _interopRequireDefault(require("ansi-colors"));

var _shared = require("../prompts/shared");

var _constants = _interopRequireDefault(require("../constants"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var PackageJson = require('@npmcli/package-json');

var PackageManager = /*#__PURE__*/function () {
  function PackageManager() {
    (0, _classCallCheck2["default"])(this, PackageManager);
    (0, _defineProperty2["default"])(this, "pkgJsonLoader", this.loadPackageJson());
  }

  (0, _createClass2["default"])(PackageManager, [{
    key: "addDevDeps",
    value: function () {
      var _addDevDeps = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(packages) {
        var deps, pkgJson;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                deps = packages.map(function (pkg) {
                  return [pkg, _constants["default"].packages[pkg]];
                });
                _context.next = 3;
                return this.pkgJsonLoader;

              case 3:
                pkgJson = _context.sent;
                pkgJson.update({
                  devDependencies: _objectSpread(_objectSpread({}, pkgJson.content.devDependencies), Object.fromEntries(deps)),
                  // @npmcli/package-json Docs says
                  // When working with dependencies, it's important to provide values for all known dependency types as the update logic has some interdependence in between these properties.
                  dependencies: pkgJson.content.dependencies,
                  peerDependencies: pkgJson.content.peerDependencies,
                  optionalDependencies: pkgJson.content.optionalDependencies
                });
                _context.next = 7;
                return pkgJson.save();

              case 7:
                console.log(_ansiColors["default"].green("\n\u2714 Added Packages \uD83D\uDE80 ".concat((0, _shared.primaryColor)(deps.map(function (_ref) {
                  var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
                      pkg = _ref2[0],
                      version = _ref2[1];

                  return "".concat(pkg, "@").concat(version);
                }).join(' ')))));

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function addDevDeps(_x) {
        return _addDevDeps.apply(this, arguments);
      }

      return addDevDeps;
    }()
  }, {
    key: "addScripts",
    value: function () {
      var _addScripts = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(scripts) {
        var pkgJson;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.pkgJsonLoader;

              case 2:
                pkgJson = _context2.sent;
                pkgJson.update({
                  scripts: _objectSpread(_objectSpread({}, pkgJson.content.scripts), scripts)
                });
                _context2.next = 6;
                return pkgJson.save();

              case 6:
                console.log(_ansiColors["default"].green("\n\u2714 Added Scripts \uD83D\uDE80 ".concat((0, _shared.primaryColor)(Object.keys(scripts).join(' ')))));

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function addScripts(_x2) {
        return _addScripts.apply(this, arguments);
      }

      return addScripts;
    }()
  }, {
    key: "update",
    value: function () {
      var _update = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(updates) {
        var pkgJson;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.pkgJsonLoader;

              case 2:
                pkgJson = _context3.sent;
                pkgJson.update(updates);
                _context3.next = 6;
                return pkgJson.save();

              case 6:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function update(_x3) {
        return _update.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "runCommand",
    value: function () {
      var _runCommand = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(command) {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return (0, _child_process.execSync)(command, {
                  stdio: 'inherit'
                });

              case 2:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      function runCommand(_x4) {
        return _runCommand.apply(this, arguments);
      }

      return runCommand;
    }()
  }, {
    key: "loadPackageJson",
    value: function () {
      var _loadPackageJson = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
        var pkgJson;
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return PackageJson.load(process.cwd());

              case 2:
                pkgJson = _context5.sent;
                return _context5.abrupt("return", pkgJson);

              case 4:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));

      function loadPackageJson() {
        return _loadPackageJson.apply(this, arguments);
      }

      return loadPackageJson;
    }()
  }]);
  return PackageManager;
}();

var _default = new PackageManager();

exports["default"] = _default;